# Copyright (c) 2018-present eyeo GmbH
#
# This module is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

---

# https://docs.ansible.com/ansible/latest/modules/copy_module.html
- name:
    "sites-available"
  copy:
    content: "{{ item.value['configuration'] }}"
    dest: "/etc/apache2/sites-available/{{ apache2_site_name }}.conf"
  vars:
    apache2_site_name: &apache2_site_name
      "{{ item.value['name'] | default(item.key) }}"
  notify:
    - "service : apache2"
  when:
    - "item.value['configuration'] is defined"
  loop:
    "{{ apache2_sites | dict2items }}"
  loop_control:
    label: "{{ [item.key, {'name': apache2_site_name}] | to_json }}"
  become:
    true

# https://docs.ansible.com/ansible/latest/modules/file_module.html
- name:
    "sites-enabled"
  file:
    path: "/etc/apache2/sites-enabled/{{ apache2_site_enabled_name }}.conf"
    src: "{{ apache2_site_enabled | ternary(apache2_site_src, omit) }}"
    state: "{{ apache2_site_enabled | ternary('link', 'absent') }}"
  vars:
    apache2_site_name: *apache2_site_name
    apache2_site_enabled: "{{ item.value['enabled'] | default(true) }}"
    apache2_site_enabled_name: "{{ item.value['enabled_site_name']
                                 | default(apache2_site_name) }}"
    apache2_site_src: "../sites-available/{{ apache2_site_name }}.conf"
  notify:
    - "service : apache2"
  loop:
    "{{ apache2_sites | dict2items }}"
  loop_control:
    label: "{{ [item.key, {'enabled': apache2_site_enabled}] | to_json }}"
  become:
    true
